<?php
// Jamroom Offline Settings module
// @package Jamroom_Library
// @copyright 2003-2008 by Brian Johnson / Talldude Networks LLC
// @author Brian Johnson - bigguy@talldude.net
// $Id: settings.php,v 1.3 2009-06-04 14:12:25 bigguy Exp $

// make sure flag as "upgrade" so we don't attempt to read our settings
define('JR_UPGRADE',true);

// set up our include files
require 'include/jamroom-include.inc.php';
$_to_check = array('Nova','Cobalt3','Sage','Flashback','Jukebox','JamTube','ProJam','MediaPro','ProJam2','Proton','Proton2','M','Cobalt');
foreach ($_to_check as $skin) {
    if (is_dir("skins/{$skin}")) {
        $config['index_template'] = $skin;
        break;
    }
}
$_user['user_classic_cp'] = 0;
if (!isset($config['index_template'])) {
    $_user['user_classic_cp'] = 1;
}

// our script name
$GLOBALS['JR_SCRIPT_NAME'] = 'settings.php';

// get the post
$_post = getPostVars();

// Make sure the setfile is there - if not, we are going to need to create a new one
if (!is_file("{$jamroom_db['set_file']}")) {
    @touch($jamroom_db['set_file'],$config['file_mode']);
    if (!is_file("{$jamroom_db['set_file']}")) {
        jrNoticePage('error','Unable to create new Master Database settings file - check jamroom/config directory permissions','install.php');
    }
}

// Define some user stuff.  Note that when the admin is running settings.php we always use the Class CP.
$_user['user_id']         = 0;
$language = getLanguage('english.lang.php');

//------------------------------
// SHOW FORM
//------------------------------
if ((!isset($_post['mode']) || strlen($_post['mode']) === 0) || $_post['mode'] == 'menu') {

    jmHtmlBegin('jamroom settings',false,false);
    jmBodyBegin(false);
    jmSpanCell('Jamroom Offline settings editor','&nbsp;');
    jrShowNotice('warning',"<b>MAKE SURE WHEN YOU ARE FINISHED USING THIS SCRIPT THAT IT IS DELETED!</b><br>Leaving this script in place in your Jamroom directory is a major security issue!",false);
    jmDivider();
    jmShowLine("Use the following Database fields if you need to modify the information Jamroom uses to connect to the database.<br><b>IMPORTANT:</b> Leave the following fields <b>empty</b> if you do not need to change your database information.",false);
    if (isset($_post['err'])) {
        if ($_post['err'] == 'server_name') {
            jrShowNotice('error','You forgot to fill in the Server Name');
        }
        elseif ($_post['err'] == 'dtbase_name') {
            jrShowNotice('error','You forgot to fill in the Database Name');
        }
        elseif ($_post['err'] == 'dtuser_name') {
            jrShowNotice('error','You forgot to fill in the Database User Name');
        }
        elseif ($_post['err'] == 'dtuser_pass') {
            jrShowNotice('error','Your New Database Passwords do not match - try again');
        }
        elseif ($_post['err'] == 'user_pass') {
            jrShowNotice('error','Your New Master Admin Passwords do not match - try again');
        }
        elseif ($_post['err'] == 'cfg') {
            jrShowNotice('error','An error was encountered writing to the Master Settings file - check permissions on the config/.htpasswd file - the config directory and config/.htpasswd file must be (temporarily) writeable by the Web User.');
        }
        else {
            jrShowNotice('error',urldecode($_post['err']));
        }
        unset($_post['err']);
    }
    $sn = urldecode($_post['server_name']);
    $dn = urldecode($_post['dtbase_name']);
    $du = urldecode($_post['dtuser_name']);
    $p1 = urldecode($_post['dtuser_pas1']);
    $p2 = urldecode($_post['dtuser_pas2']);
    $u1 = urldecode($_post['user_password1']);
    $u2 = urldecode($_post['user_password2']);

    jmBeginForm('settings.php?mode=do_change');
    jmInput('Server Name','server_name','text',$sn);
    jmInput('Database Name','dtbase_name','text',$dn);
    jmInput('Database User Name','dtuser_name','text',$du);
    jmInput('Database Password','dtuser_pas1','password',$p1);
    jmInput('Repeat Database Password','dtuser_pas2','password',$p2);
    jmDivider();
    jmShowLine("Use these password fields if you need to reset or change the Master Admin login name or password.<br><b>IMPORTANT:</b> Leave these fields <b>empty</b> if you do not want to change the Master Admin login name or password.",false);
    jmInput('New Admin Name','user_nickname','text',$un);
    jmInput('New Admin Password','user_password1','password',$u1);
    jmInput('Repeat Admin Password','user_password2','password',$u2);
//    jmDivider();
//    jmCheckBox('Reset Admin Allowed Ips','reset_admin_ips','Check this box if you would like to reset the Admin Allowed IPs in the Jamroom Config (this helps if you have locked yourself out as Admin)');
//    jmCheckBox('Reset Session Domain','reset_session_domain','Check this box if you would like to reset the Session Domain on your site - if your Session Domain has been set incorrectly, you will not be able to log in to your Jamroom.');
//    jmDivider();
    $tmp = jrHtmlButtonCode('run jamroom integrity check','window.location = \'settings.php?mode=integrity\';');
    jmLinkCell('Jamroom Integrity Check',$tmp);
    jmDivider();
    jmSubmitClear('modify settings');
    jmEndForm();
    jmBodyEnd();
    jmHtmlEnd();
    exit;
}

//------------------------------
// DO_CHANGE
//------------------------------
elseif (isset($_post['mode']) && $_post['mode'] == 'do_change') {

    // Make sure we remove white space
    $_post['server_name']   = trim($_post['server_name']);
    $_post['dtbase_name']   = trim($_post['dtbase_name']);
    $_post['dtuser_name']   = trim($_post['dtuser_name']);
    $_post['user_nickname'] = trim($_post['user_nickname']);

    // Save our post vars
    $sn = urlencode($_post['server_name']);
    $dn = urlencode($_post['dtbase_name']);
    $du = urlencode($_post['dtuser_name']);
    $p1 = urlencode($_post['dtuser_pas1']);
    $p2 = urlencode($_post['dtuser_pas2']);
    $un = urlencode($_post['user_nickname']);
    $u1 = urlencode($_post['user_password1']);
    $u2 = urlencode($_post['user_password2']);

    $xu = "&server_name={$sn}&dtbase_name={$dn}&dtuser_name={$du}&dtuser_pas1={$p1}&dtuser_pas2={$p2}&user_nickname={$un}&user_password1={$u1}&user_password2={$u2}";

    // First see if we are resetting our database info at all
    $update_htaccess = false;
    if (strlen($_post['server_name']) > 0 || strlen($_post['dtbase_name']) > 0 || strlen($_post['dtuser_name']) > 0) {

        // Check Server Name
        if (strlen($_post['server_name']) === 0) {
            header('Location: settings.php?mode=menu&err=server_name'. $xu);
            exit;
        }
        // Check Database Name
        if (strlen($_post['dtbase_name']) === 0) {
            header('Location: settings.php?mode=menu&err=dtbase_name'. $xu);
            exit;
        }
        // Check Database User Name
        if (strlen($_post['dtuser_name']) === 0) {
            header('Location: settings.php?mode=menu&err=dtuser_name'. $xu);
            exit;
        }
        // Check Database User Password
        if (strlen($_post['dtuser_pas1']) === 0 || strlen($_post['dtuser_pas2']) === 0 || $_post['dtuser_pas1'] != $_post['dtuser_pas2']) {
            header('Location: settings.php?mode=menu&err=dtuser_pass'. $xu);
            exit;
        }

        // Verify MySQL Settings
        $con = @mysql_connect($_post['server_name'],$_post['dtuser_name'],$_post['dtuser_pas1']) or $merr = 'MySQL error '. mysql_errno() .' - '. mysql_error();
        if (!empty($merr)) {
            header('Location: settings.php?mode=menu&err='. urlencode($merr) . $xu);
            exit;
        }
        @mysql_select_db($_post['dtbase_name'],$con) or $merr = 'MySQL error '. mysql_errno() .' - '. mysql_error();
        if (!empty($merr)) {
            header('Location: settings.php?mode=menu&err='. urlencode($merr) . $xu);
            exit;
        }
        $update_htaccess = true;
    }

    // Verify Admin Passwords if given
    $user_pass = '';
    if (strlen($_post['user_password1']) > 0 || strlen($_post['user_password2']) > 0) {
        if ($_post['user_password1'] != $_post['user_password2']) {
            header('Location: settings.php?mode=menu&err=user_pass'. $xu);
            exit;
        }
        $user_pass = md5($_post['user_password1']);
    }

    // Update our database settings if asked to do so
    if ($update_htaccess === true) {

        // get our current Master Config file if it exists
        $_cur = array();
        if (is_file('config/.htpasswd')) {
            $_cur = readMasterConfig();
        }
        else {
            $_cur[4] = time();
        }
        // Prep our array for our new config file
        $_dat = array (
          $_post['server_name'],
          $_post['dtbase_name'],
          $_post['dtuser_name'],
          $_post['dtuser_pas1']
        );
        $GLOBALS['JR_HTPASSWD'][4] = $_cur[4];
        // Now set our new info
        if (setMasterConfig($_dat) === false) {
            unset($_post['mode']);
            header("Location: settings.php?mode=menu&err=cfg". $xu);
            exit;
        }
    }

    // See if we are resetting the Master Password
    if (isset($user_pass)&& strlen($user_pass) === 32) {
        $con = dbConnect();
        $req = "UPDATE {$jamroom_db['user']} SET
                  user_password = '". dbEscapeString($user_pass) ."'
                 WHERE user_id = '0'
                 LIMIT 1";
        $cnt = dbQuery($req,'COUNT');
        dbClose();
    }
    // See if we are doing master admin name
    if (isset($_post['user_nickname']) && strlen($_post['user_nickname']) > 0) {
        $con = dbConnect();
        $req = "UPDATE {$jamroom_db['user']} SET
                  user_nickname = '". dbEscapeString($_post['user_nickname']) ."'
                 WHERE user_id = '0'
                 LIMIT 1";
        $cnt = dbQuery($req,'COUNT');
        if (!isset($cnt) || $cnt == '0') {
            // Looks like our admin acount may be toast - let's see if we can recreate it
            $req = "SELECT *
                      FROM {$jamroom_db['user']}
                     WHERE user_id = '0'
                     LIMIT 1";
            $_rt = dbQuery($req,'SINGLE');
            if (!isset($_rt) || !is_array($_rt)) {
                $req = "INSERT INTO {$jamroom_db['user']} (user_id,user_group_id,user_nickname,user_password)
                        VALUES ('0','0','". dbEscapeString($_post['user_nickname']) ."','". dbEscapeString($user_pass) ."')";
                $cnt = dbQuery($req,'COUNT');
            }
        }
        dbClose();
    }
    // See if we are resetting the Admin Allowed IPs
    if (isset($_post['reset_admin_ips']) && $_post['reset_admin_ips'] == 'on') {
        $req = "UPDATE {$jamroom_db['settings']} SET
                  ip_allowed = ''";
        dbQuery($req);
        dbClose();
    }
    // See if we are resetting the Session Domain
    if (isset($_post['reset_session_domain']) && $_post['reset_session_domain'] == 'on') {
        $req = "UPDATE {$jamroom_db['settings']} SET
                  session_domain = ''";
        dbQuery($req);
        dbClose();
    }
    jrNoticePage('success',"Your settings have been successfully modified - note that your Master Settings file has been backed up.<br><br><b>*** IMPORTANT ***<br><br>REMOVE THIS FILE (settings.php) IMMEDIATELY!</b><br><br>Leaving this file in place is a severe security risk!  You will continue to see an ERROR message (when logged in as the Master Admin) in your Jamroom until this file is removed.",'login.php',false,'_top',false);
}
//------------------------------
// INTEGRITY
//------------------------------
elseif (isset($_post['mode']) && $_post['mode'] == 'integrity') {

    jmHtmlBegin("Jamroom Integrity Check",false,false);
    jmBodyBegin(false);
    jmSpanCell("Jamroom Integrity Check","please be patient while Jamroom performs an integrity check.",'30','html_modify.png');
    // Force our flush here so we see the updates
    jrHtmlShowForm();

    jrHtmlProgressLine('Verifying Database Table and Column integrity...');

    // Now we need to go through each table and repair
    $GLOBALS['no_dbquery_error'] = true;
    foreach ($jamroom_db as $key => $table) {
        // some entries we don't want to process
        if ($key == 'set_file' || $key == 'database') {
            continue;
        }
        // check to see if our table exists
        $req = "REPAIR TABLE {$table}";
        dbQuery($req);
        jrHtmlProgressLine('Database Integrity Check of '. $table .' completed.');
    }
    unset($GLOBALS['no_dbquery_error']);

    // make sure we are up to date
    require_once 'include/jamroom-schema.inc.php';
    dbVerifyDatabase();

    jrShowNotice('success',"Database Integrity Check completed");
    jmRefresh(false,'settings.php?mode=menu','_self');
    jmBodyEnd();
    jmHtmlEnd();
    exit;
}

//------------------------------
// UNKNOWN MODE
//------------------------------
else {
    jrInvalidOption();
}
?>
